import java.util.Random;

public class Philosoph extends Thread {
    private Tisch t;
    private int id;
    private Random rnd;

  Philosoph(Tisch tt, int i) {
    t = tt;
    id = i;
    rnd = new Random( id );
  }

  private void denken() {
      System.out.println("Philosoph " + id + " denkt...");

      try { Thread.sleep(rnd.nextInt(10) * 1); }
      catch(InterruptedException e) {}

      System.out.println("Philosoph " + id + " hat genug gedacht...");
  }

  private void essen() {
      System.out.println("Philosoph " + id + " isst...");

      try { Thread.sleep(rnd.nextInt(10) * 1); }
      catch(InterruptedException e) {}

      System.out.println("Philosoph " + id + " hat genug gegessen...");
  }

  public void run() {
    while (true) {
      denken();

      synchronized( t ) {
	  while( t.gabel[id].belegt ||
		 t.gabel[(id+1) % t.n].belegt ) {
	      try {
		  t.wait();
	      }
	      catch(InterruptedException e) {};
	  }

	  System.out.println(id + " nimmt linke Gabel...");
	  t.gabel[id].belegen(id);
	  System.out.println(id + " nimmt rechte Gabel...");
	  t.gabel[(id+1) % t.n].belegen((id+1) % t.n);
      }

      essen();

      synchronized( t ) {
	  System.out.println(id + " entlaesst linke Gabel...");
	  t.gabel[id].freigeben(id);
	  System.out.println(id + " entlaesst rechte Gabel...");
	  t.gabel[(id+1) % t.n].freigeben((id+1) % t.n);

	  t.notifyAll();
      }
    }
  }
}
